package com.primeton.esb.demo;

import java.io.ByteArrayInputStream;
import java.util.Map; 
import org.dom4j.Document;
import org.dom4j.Element;
import org.dom4j.Namespace;
import org.dom4j.Node;
import org.dom4j.io.SAXReader; 
import com.primeton.esb.message.ITipMessagePayload;
import com.primeton.esb.message.TipMessageBuilder; 

public class MsgHelper {
	public ITipMessagePayload modify(ITipMessagePayload inMessage) throws Exception {
		String body = new String((byte[]) inMessage.getMessagePayload()); 
		SAXReader saxReader = new SAXReader();
		Document document = saxReader.read(new ByteArrayInputStream(body.getBytes("UTF-8")));
		Node node = document.selectSingleNode("//soapenv:Body/xsd:getCustByID");
		node.setName("xsd:getCustomerByID");
		Node childNode = node.selectSingleNode("//xsd:custid");
		childNode.setName("xsd:customerid");
		childNode.setText("2");
		Element rootElement = document.getRootElement(); 
		rootElement.remove(new Namespace("xsd",
		"http://ws.apache.org/axis2/samples/Cust/xsd/"));
		rootElement.addNamespace("xsd",
		"http://ws.apache.org/axis2/samples/Customer/xsd/");
		String modifiedBody = rootElement.asXML(); 
		TipMessageBuilder builder = TipMessageBuilder.withPayload(modifiedBody); 
		builder.copySystemHeaders(inMessage.getSystemHeaders());
		((Map) inMessage.getProtocolHeaders()).put("SOAPAction", "getCustomerByID");
		((Map) inMessage.getProtocolHeaders()).put("Content-Length", String
		.valueOf(modifiedBody.length()));
		builder.setProtocolHeaders(inMessage.getProtocolHeaders()); 
		return builder.build();
		}
}
